package main

import (
	"demos/ops/ml"
	"flow"
	"log"
)

func main() {

	r := ml.New()

	f := flow.New()
	f.UseRegistry(r)

	samples := [][]float64{
		{0, 0},
		{0, 1},
		{1, 0},
		{1, 1},
	}
	labels := []float64{1, 0, 0, 1}
	_ = samples
	_ = labels

	// Try binary operations first
	// 2 inputs 1 output
	// Load minst somehow 28x28 784
	nSample := 2

	learningRate := float64(1.0)
	_ = learningRate
	// Load minst into floats array

	// Make a matrix from the weights variable
	// 5 outputs

	// Layer 1
	//
	sample := samples[nSample]
	label := labels[nSample] // Label output

	process := func(op flow.Operation) flow.Data { // just an helper
		res, err := op.Process(sample, []float64{label})
		if err != nil {
			panic(err)
		}
		return res
	}

	// Define input
	// Make a matrix out of the input
	input := f.Op("matNew", 2, 1, f.In(0))
	log.Println("inMat:", process(input))

	output := f.Op("matNew", 1, 1, f.In(1))
	log.Println("inRes:", process(output))

	// Layer1 weights 2 in 3 out
	w1 := f.Op("matNew", 3, 2, f.Var("w1", f.Op("normFloat", 3*2)))
	log.Println("w1 weights:", process(w1))
	// Layour 1 result
	l1res := f.Op("matSigmoid", f.Op("matMul", w1, input))

	// weights 2 // 3 in 1 out
	w2 := f.Op("matNew", 1, 3, f.Var("w2", f.Op("normFloat", 1*3)))
	log.Println("w2 weights:", process(w2))

	// Layour 2 result
	l2res := f.Op("matSigmoid", f.Op("matMul", w2, l1res))

	log.Println("Layer2 result:", process(l2res))
	// Network output

	//////////////////////
	// Create trainer ops
	/////////
	// Backpropagation

	log.Println("Grab error from output layer")
	errOp := f.Op("matSub", output, l2res)
	log.Println("ErrorOp:", process(errOp))

	log.Println("Calculate deltas")
	deltaOp := f.Op("matMulElem", f.Op("matSigmoidD", l2res), errOp)
	log.Println("Delta:", process(deltaOp))

	outChangesOp := f.Op("matMul", l2res, deltaOp)
	log.Println("Changes to be made", process(outChangesOp))

	/*
		outChangesOp = f.Op("matScale", outChangesOp, learningRate)

		train1 := f.SetVar("w2", f.Op("matAdd", outChangesOp, w1))
		// Set Var w1
		//
		log.Println("Training 1")
		log.Println(train1.Process(sample))

		log.Println("deltaOutputLayer")
		log.Println(deltaOp.Process(sample))

		// Do we need this?
		//netOp := f.Op("toFloatArr", l2op)*/

	/*netResI, _ := netOp.Process(sample)
	res := netResI.([]float64)
	log.Println("Network result:", res)
	log.Println("Error", sample[0]-res[0], sample[1]-res[1])*/
	// Back propagation

	//log.Println(layerRes.Process(samples[0]))

	// Operation
	/*mulRes := f.Op("matrixMul", w1, inp)
	res, _ := mulRes.Process([]float64{0, 0})

	sig := f.Op("matrixSigmoid", mulRes)

	res, _ = sig.Process(samples[0])

	log.Println("Result:", res)*/
	//f.Analyse(os.Stdout, []float64{0, 1})

	// weights

}
